

wowClassIcons = {};


local wowClassIcons = wowClassIcons;




do
	local scripts = CreateFrame("Frame", "wowClassIcons_ScriptsFrame", WorldFrame);
	
	scripts:Hide();
	
	scripts:RegisterEvent("PLAYER_ENTERING_WORLD");
	scripts:RegisterEvent("PLAYER_TARGET_CHANGED");
	scripts:RegisterEvent("PARTY_MEMBERS_CHANGED");
	
	scripts.WOWCLASSICONS = wowClassIcons;
	wowClassIcons.SCRIPTS_FRAME = scripts;
end



do
	local createFrame = CreateFrame;
	local uiParent = UIParent;
	
	local globalEnv = getfenv(0);
	
	
	local target = createFrame("Frame", "wowClassIcons_TargetIconFrame", uiParent, "wowClassIcons_XML");
	
	target:SetWidth(32);
	target:SetHeight(32);
	target:SetPoint("TOPRIGHT", "TargetFrame", "TOPRIGHT", -85, -5);
	
	wowClassIcons.ICONFRAME_TARGET = target;
	
	
	local partyIcon;
	
	for index = 1, 4 do
		partyIcon = createFrame("Frame", ("wowClassIcons_Party"..index.."IconFrame"), uiParent, "wowClassIcons_XML");
		
		partyIcon:SetPoint("TOPLEFT", ("PartyMemberFrame"..index), "TOPLEFT", 30, 0);
		
		wowClassIcons["ICONFRAME_PARTY"..index] = partyIcon;
	end
end



wowClassIcons.Original_RaidOptionsFrame_UpdatePartyFrames = RaidOptionsFrame_UpdatePartyFrames;




function wowClassIcons:Main_OnEvent(event)
	if (event == "PLAYER_TARGET_CHANGED") then
		self:Main_UpdateTarget();
	elseif (event == "PARTY_MEMBERS_CHANGED" or event == "PLAYER_ENTERING_WORLD") then
		self:Main_UpdateParty();
	end
end


wowClassIcons.SCRIPTS_FRAME:SetScript("OnEvent", (function(self, event, ...) self.WOWCLASSICONS:Main_OnEvent(event); end));




function wowClassIcons:Main_UpdateTarget()
	local targetIcon = self.ICONFRAME_TARGET;
	
	if (UnitIsPlayer("target") ~= nil and UnitCreatureFamily("target") == nil) then
		local _, class = UnitClass("target");
		targetIcon.TEXTURE:SetTexture("Interface\\AddOns\\wowClassIcons\\Textures\\"..class);
		targetIcon:Show();
	else
		targetIcon:Hide();
	end
end




function wowClassIcons:Main_UpdateParty()
	if (HIDE_PARTY_INTERFACE == "1" and GetNumRaidMembers() > 0) then
		for index = 1, 4 do
			self["ICONFRAME_PARTY"..index]:Hide();
		end
		return;
	end
	
	
	local unitClass = UnitClass;
	local partyIcon;
	local _, class;
	
	for index = 1, 4 do
		partyIcon = self["ICONFRAME_PARTY"..index];
		_, class = unitClass("party"..index);
		
		if (class ~= nil) then
			partyIcon.TEXTURE:SetTexture("Interface\\AddOns\\wowClassIcons\\Textures\\"..class);
			partyIcon:Show();
		else
			partyIcon:Hide();
		end
	end
end




RaidOptionsFrame_UpdatePartyFrames = function()
	wowClassIcons.Original_RaidOptionsFrame_UpdatePartyFrames();
	
	wowClassIcons:Main_UpdateParty();
end

